<?php /*

  This file provides 
  a) header and footer for the account admin pages
  b) utility functions:
     get_or_post($key) 
     clean_form_data($data, $type)
  c) configuration variables:

*/

$debug = 0;

if ($debug == 1) {
   error_reporting(E_ALL ^ E_NOTICE);
} else {
   error_reporting(0);
}

$mytitle = "";

/**************************************************************************
 *
 * output_header($title) creates the standard top-of-page <head> content
 *
 **************************************************************************/

function output_header($title) {
  global $mytitle;

  $mytitle = $title;

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<html>
<head>
<title>
<?php echo $mytitle; ?>
</title>

<link rel="stylesheet" href="/css/admin.css" type="text/css">

</head>
<?php
}

/**************************************************************************
 *
 * output_top() creates the standard top-of-page <body> content
 *
 **************************************************************************/

function output_top() {
  global $mytitle;
?>
<body>

<!-- top banner and explanation -->
<div>
<a href="http://www.cam.ac.uk">
   <img class=banner alt="[Univ of Cambridge]" 
    src="http://www.eng.cam.ac.uk/images/house_style/uniban-s.gif"></a>
<a href="http://www.eng.cam.ac.uk">
   <img class=banner alt="[Dept of Engineering]" 
    src="http://www.eng.cam.ac.uk/images/house_style/engban-s.gif"></a>
</div>

<div style="width: 90%; margin-left: 5%">
<h1>
<?php echo $mytitle; ?>
</h1>

<?php
}

/**************************************************************************
 *
 * output_tail() creates the standard bottom-of-page <body> content
 *
 **************************************************************************/

function output_tail() {
?>
<!-- footer -->

<hr>
<div id=foot>
<p> 
</p>

</div>
</body>
</html>

<?php
}

/**************************************************************************
 *
 * get_form_values($keys) expects to be passed an empty array and fills
 * it with what was passed through a form
 *
 **************************************************************************/

function get_or_post($key) {

   $res=$_POST[$key];

   if (strlen($res) < 1) {
      $res = $_GET[$key];
   }
   return($res);
}

function clean_form_data($data, $type = 'alphanum', $nullallowed = 0) {

   switch ($type) {
      case 'username':
	$res = preg_replace('/[^a-zA-Z0-9-]/', '', $data);
        break;
      case 'multidirname': /* multiple level subdirectory */
        /* remove all embedded \..\ and trailing \.. */ 
	$res = preg_replace('/(\/\.\.\/)|(\/\.\.$)/', '', $data);
        /* remove all prefix / and .. (repeatedly!) */
        $res = preg_replace('/^(\/|\.\.)+/', '', $res);
	break;
      case 'fname': /* single directory or file name */
        /* remove all / throughout */
        $res = preg_replace('/\//', '', $data);
	$res = preg_replace('/^(\.\.)+/', '', $data);
	break;
      case 'striphtml':  /* make sure no markup gets through */
        $res = htmlentities($data);
	break;
      case 'email':
	$res = preg_replace('/[^a-zA-Z0-9@\.-]/', '', $data);
	break;
      case 'alphanum':
      default:
        $res = preg_replace('/[^a-zA-Z0-9]/', '', $data);
        break; 	
   }

   if ((strlen($res) == 0) && !$nullallowed) {
	$res = "NULLSTRING";
   }

   return($res);
}

function make_mailto($email, $text = '') {
   echo '<a href="http://www.eng.cam.ac.uk/contact_addresses.shtml>';

   $email = preg_replace('/@.*/', '', $email);

   if (strlen($text) == 0) {
      echo "$email";
   } else {
      echo "$text ($email)";
   }
   echo '</a>\n';
} 
