<?php

   /* this is just a friendly way of automatically generating a reasonably
      sensible stand-alone form that'll make use of the upload.php 
      script, configured for a particular upload directory */

   include_once('wrapper.php');

   function failure($info) {
      output_header($ftp_ftp_host." file upload form");
  
      output_top();

      echo "<p>Attempt to generate upload form failed.  The error message was:\n";
      echo "<pre>$info</pre>\n";
      echo "</p>\n"; 

      output_tail();
      exit;
   }

   $baseurl='http://'.$ftp_web_host.'/upload.php?';

   /* allow null directory (3rd arg to clean_form_data()), because 
      we test for this immediately after */
   $uploaddir=clean_form_data(
               clean_form_data(get_or_post('uploaddir'), 'multidirname', 1),
               'striphtml', 1);

   $uploaddirtype=clean_form_data(get_or_post('type'), 'alphanum', 1);

   if (strlen($uploaddir) == 0) {
      unlink($ul_tmp_name);
      failure("attempt to cause zero-length upload subdirectory");
   }

   switch($uploaddirtype) {
      case 'user':
        $uploaddir="user/".$uploaddir;
 	break;
      case 'group':
	break;
      default:
	failure("need to specify type=group or type=user .<br><br>NB if you typed the url on a unix command line,<br>you may have needed to protect the &quot;&amp;&quot; character with quotes");
	break;
   }


   /* optional arguments to pass */

   $title = clean_form_data(get_or_post('title'), 'striphtml', 1);

   if (strlen($title) == 0) {
      $title = "Anonymous ftp upload to \"$uploaddir\" on ".$ftp_ftp_host;
   }

   $contact = clean_form_data(get_or_post('contact'), 'email', 1);

   if (strlen($contact) == 0) {
      $contact = clean_form_data('webadmin@eng.cam.ac.uk', 'email', 0);
   }	

   $maxsize = clean_form_data(get_or_post('maxsize'), 'integer', 1);

   if (strlen($maxsize) == 0) {
      $maxsize = return_bytes(ini_get('post_max_size'));
   }

   if ($maxsize > return_bytes(ini_get('post_max_size'))) {
      $maxsize = return_bytes(ini_get('post_max_size'));
   }

   if ($maxsize > return_bytes(ini_get('upload_max_filesize'))) {
      $maxsize = return_bytes(ini_get('upload_max_filesize'));
   }
 
   output_header($title);

   output_top();

?>

<p>
This form provides a mechanism for uploading a file from your computer
into the &quot;<?php echo "$uploaddir"; ?>&quot; upload directory on 
<code><?php echo "$ftp_ftp_host" ?></code> .  
<p>
Any file uploaded in this way will <em>not</em> be visible to anyone
other than the maintainer of the upload directory.  In particular it
is not possible to use this web interface, or anonymous ftp, to access
the uploaded copy of the file.
<p>
<form enctype="multipart/form-data"
      action="http://<?php echo "$ftp_web_host"; ?>/upload.php"
      method="POST">

<input type="hidden" 
       name="MAX_FILE_SIZE" 
       value="<?php echo "$maxsize" ?>" />
<input type="hidden" 
       name="uploaddir"
       value="<?php echo "$uploaddir" ?>" />
Submit this file: 
<input type="file"
       name="uploadfile" />
<input type="submit" value="Send File" />
</form>
</p>
<hr>

<?php
   output_tail();

?>
