<?php

  /* 
   * This is intended to be an embeddable script, usable within other
   * peoples' web pages as the target of a <form>.
   *
   * It is intended that it should implement the same access restrictions
   * and uploading behaviour as the ftpd running on this machine.
   *
   * When embedded in another web page, it can be passed html data 
   * in result_page_data which will be used as its output, with some
   * substitutions made as follows
   *
   *  
   * 
   */


   include_once('wrapper.php');

function failure($info, $redirect_on_failure = "") {
   error_log($info);

   if (strlen($redirect_on_failure) == 0) {

       output_header($ftp_ftp_host." file uploads");
  
       output_top();

?>
<p>
This page failed to work.  More information will be available to
the administrators of this system in their error logs.
<p>
One possible explanation is that you have tried to upload to a filename
that already exists.
<p>
Another is that the file you tried to upload is larger than the current
system-imposed limit (which is 
<?php
   $maxsize = return_bytes(ini_get('post_max_size'));
   if ($maxsize > return_bytes(ini_get('upload_max_filesize'))) {
      $maxsize = return_bytes(ini_get('upload_max_filesize'));
   }

   if ($maxsize > 1024) {
      $maxletter = 'K';
      $maxsize /= 1024;
   }
   if ($maxsize > 1024) {
      $maxletter = 'M';
      $maxsize /= 1024;
   }
   if ($maxsize > 1024) {
      $maxletter = 'G';
      $maxsize /= 1024;
   }
   echo "$maxsize$maxletter";

?>
)
</p>
<?php 
      output_tail();
      exit;
   
   } else {



      header("Location: $redirect_on_failure");
      exit;
   }
}

   $ul_tmp_name = $_FILES['uploadfile']['tmp_name'];
   $ul_name = $_FILES['uploadfile']['name'];
   $ul_copy_name = $php_tmp_copy_dir . "/" . 
                    basename($_FILES['uploadfile']['tmp_name']);

   /* same modification of ${filename} in url as is used and documented for redirect_on_success: */

   $redirect_on_failure = str_replace('${filename}', urlencode($ul_name), get_or_post('redirect_on_failure'));

   if (!is_uploaded_file($ul_tmp_name)) {
      failure("is_uploaded_file() on 'uploadfile' ($ul_tmp_name) returned false", $redirect_on_failure);
   }

   if (strncmp($ul_tmp_name, $php_tmp_upload_dir."/", 
               strlen($php_tmp_upload_dir)+1)) {
      failure("uploaded tmp filename $ul_tmp_name is not in $php_tmp_upload_dir", $redirect_on_failure);
   }

   if (!move_uploaded_file($ul_tmp_name, $ul_copy_name)) {
	unlink($ul_tmp_name);
        failure("move_uploaded_file($ul_tmp_name, $ul_copy_name) failed", 
                $redirect_on_failure);
   }

   $uploaddir=get_or_post('uploaddir');

   /* allow null directory (3rd arg to clean_form_data()), because 
      we test for this immediately after */
   $uploaddir=clean_form_data($uploaddir, 'multidirname', 1);

   if (strlen($uploaddir) == 0) {
      unlink($ul_tmp_name);
      failure("attempt to cause zero-length upload subdirectory", $redirect_on_failure);
   }

   $uploadfname=get_or_post('uploadfname');

   $uploadfname=clean_form_data($uploadfname, 'fname', 1);

   if (strlen($uploadfname) == 0) {
      $uploadfname = clean_form_data($ul_name, 'fname', 1);
      if (strlen($uploadfname) == 0) {
         unlink($ul_tmp_name);
         failure("attempt to cause zero-length upload filename", $redirect_on_failure);
      }
   }

   /* we've now moved the uploaded file into the staging directory;
      now to construct the final url of the anon ftp upload */

   $ftp_url = "ftp://".$ftp_ftp_host."/pub/upload/" .  
              $uploaddir . "/" . $uploadfname; 
   
   #
   # although this use of copy() and an ftp: url is neater, it
   # triggers a recurring bug in pure-ftpd 8-(
   #
   #if (!copy($ul_copy_name, $ftp_url)) {
   #   unlink($ul_copy_name);
   #   failure("attempt to copy $ul_copy_name to $ftp_url failed", $redirect_on_failure);
   #}

   # new version using php5-ftp library, so as to avoid tickling the
   # pure-ftpd recurring bug with over-quick use of command channel
   # after the client has closed the data channel (which pure-ftpd
   # interprets as an abort.

   $conn_id = ftp_connect('ftp.eng.cam.ac.uk');
   if (!$conn_id) {
      unlink($ul_copy_name);
      failure("attempt to copy $ul_copy_name to $ftp_url failed (couldn't connect)", $redirect_on_failure);
   }
   $login_result = ftp_login($conn_id, 'anonymous', 'php-upload');
   if (!$login_result) {
      unlink($ul_copy_name);
      failure("attempt to copy $ul_copy_name to $ftp_url failed (couldn't login anonymous)", $redirect_on_failure);
   }
   ftp_pasv($conn_id, true);
   $upload = ftp_put($conn_id, "/pub/upload/" . $uploaddir . "/" . $uploadfname, $ul_copy_name, FTP_BINARY);
   if (!$upload) {
      unlink($ul_copy_name);
      failure("attempt to copy $ul_copy_name to $ftp_url failed (couldn't put file)", $redirect_on_failure);
   }
   usleep(100000);
   ftp_close($conn_id);

   /*

   $eventual_dest = $ftp_data_dir."/pub/upload/" . $uploaddir . "/" .
	$uploadfname;	 

   if (!file_exists($eventual_dest)) {
      unlink($ul_copy_name);
      failure("attempt to copy $ul_copy_name to $ftp_url failed:  couldn't find $eventual_dest", $redirect_on_failure);
   }
   */

   unlink($ul_copy_name);

   $redirect_on_success=get_or_post('redirect_on_success');

   if (strlen($redirect_on_success) == 0) {

       output_header($ftp_ftp_host." file uploads");
  
       output_top();
?>
<p>
Web transfer from your local file 
<?php echo "&ldquo;".clean_form_data($ul_name, 'striphtml', 1)."&rdquo;"; ?>
 to the anonymous ftp location
<?php echo "&ldquo;$ftp_url&rdquo;"; ?>
 was successful.
<p>
You should not expect the file to be downloadable again from that
location.
</p>
<?php

      output_tail();

  } else {
  /* we're assuming here that someone wants a successful upload to 
     redirect to a "success" page under their control. */


  /* as an additional facility, we allow the instantiation of
     certain variables within the redirect_on_success string .
     Currently, the only variables supported are:
  
     ${filename} :  the name on the local client of the file uploaded 

     the filename is encoded, so that only rfc2396 unreserved chars
     are preserved unchanged

*/

     $redirect_on_success = 
         str_replace('${filename}', urlencode($ul_name), $redirect_on_success);

     header("Location: $redirect_on_success");
     exit;

  }

?>
