<?php /*

  This file provides 
  a) header and footer for the admin pages
  b) utility functions:
     get_or_post($key) 
     clean_form_data($data, $type)
     return_bytes($string)
  c) configuration variables:
     $ftp_data_dir = location of the anonymous ftp data directory 

*/

$debug = 0;

if ($debug == 1) {
   error_reporting(E_ALL ^ E_NOTICE);
} else {
   error_reporting(0);
}

$ftp_web_host = 'ftp-serv.eng.cam.ac.uk';
$ftp_ftp_host = 'ftp-serv.eng.cam.ac.uk';
$admin_email = 'webadmin@eng.cam.ac.uk';
$ftp_data_dir = '/data/anonftp';
$php_tmp_upload_dir = '/data/php_tmp';
$php_tmp_copy_dir = '/data/php_staging';

$mytitle = "";


/*
 *
 * return_bytes($string) converts strings like 512M to byte counts
 *
 */

function return_bytes($val) {
   $val = trim($val);
   $last = strtolower($val{strlen($val)-1});
   switch($last) {
      case 'g':
         $val *= 1024;
      case 'm':		 
         $val *= 1024;
      case 'k':
         $val *= 1024;
   }
   return $val;
}

 

/**************************************************************************
 *
 * output_header($title) creates the standard top-of-page <head> content
 *
 **************************************************************************/

function output_header($title) {
  global $mytitle;

  $mytitle = $title;

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>

<title>
<?php echo $mytitle; ?>
</title>

<?php
  readfile("/usr/local/www/htdocs/global/includes/cued-h.html");
  readfile("/usr/local/www/htdocs/global/includes/cued-bread.html");
?>

  <!-- CONTENT -->

<?php
}

/**************************************************************************
 *
 * output_top() creates the standard top-of-page <body> content
 *
 **************************************************************************/

function output_top() {
  global $mytitle;
?>
<h1>
<?php echo $mytitle; ?>
</h1>

<?php
}

/**************************************************************************
 *
 * output_tail() creates the standard bottom-of-page <body> content
 *
 **************************************************************************/

function output_tail() {
?>
<!-- FOOTER -->

<?php
   readfile("/usr/local/www/htdocs/global/includes/cued-line.html");
?>
<!-- add your email and last updated date below -->
<span class="footercued">
<a href="http://www.eng.cam.ac.uk/copyright.html">&copy;</a>&nbsp;Cambridge University Engineering Dept<br />
Information provided by <a href="http://www.eng.cam.ac.uk/contact_addresses.shtml">

jpmg</a><br />

</span>
</body>
</html>


<?php
}

/**************************************************************************
 *
 * get_form_values($keys) expects to be passed an empty array and fills
 * it with what was passed through a form
 *
 **************************************************************************/

function get_or_post($key) {

   $res=$_POST[$key];

   if (strlen($res) < 1) {
      $res = $_GET[$key];
   }
   return($res);
}

function clean_form_data($data, $type = 'alphanum', $nullallowed = 0) {

   switch ($type) {
      case 'username':
	$res = preg_replace('/[^a-zA-Z0-9-]/', '', $data);
        break;
      case 'multidirname': /* multiple level subdirectory */
        /* remove all embedded \..\ and trailing \.. */ 
	$res = preg_replace('/(\/\.\.\/)|(\/\.\.$)/', '', $data);
        /* remove all prefix / and .. (repeatedly!) */
        $res = preg_replace('/^(\/|\.\.)+/', '', $res);
	break;
      case 'fname': /* single directory or file name */
        /* remove all / throughout */
        $res = preg_replace('/\//', '', $data);
	$res = preg_replace('/^(\.\.)+/', '', $data);
	break;
      case 'striphtml':  /* make sure no markup gets through */
        $res = htmlentities($data);
	break;
      case 'email':
	$res = preg_replace('/[^a-zA-Z0-9@\.-]/', '', $data);
	break;
      case 'alphanum':
      default:
        $res = preg_replace('/[^a-zA-Z0-9]/', '', $data);
        break; 	
   }

   if ((strlen($res) == 0) && !$nullallowed) {
	$res = "NULLSTRING";
   }

   return($res);
}

function make_mailto($email, $text = '') {
   echo '<a href="http://www.eng.cam.ac.uk/contact_addresses.shtml>';

   $email = preg_replace('/@.*/', '', $email);

   if (strlen($text) == 0) {
      echo "$email";
   } else {
      echo "$text ($email)";
   }
   echo '</a>\n';
} 
